## python3.13 3.13.1

=== debian/changelog ===
python3.13 (3.13.1-3) unstable; urgency=medium

  [ Stefano Rivera ]
  * Drop patch sysconfigdata-name.diff, upstream rejected it and we no longer
    need it.
  * Add compatibility symlink for old sysconfigdata name.

  [ Matthias Klose ]
  * Update to the 3.13 branch 2025-01-03.
    - Fix issue #128030. Closes: #1090267.

 -- Matthias Klose <doko@debian.org>  Fri, 03 Jan 2025 11:26:34 +0100

python3.13 (3.13.1-2) unstable; urgency=medium

  * Update to the 3.13 branch 2024-12-12.
    - Fix issue #127655, CVE-2024-12254.
  * Add support for OpenSSL 3.4, issue #127330.
  * Mark test_structseq as failing on Ubuntu/armhf.

 -- Matthias Klose <doko@debian.org>  Thu, 12 Dec 2024 11:12:28 +0100

python3.13 (3.13.1-1) unstable; urgency=medium

  * Python 3.13.1.

  [ Matthias Klose ]
  * Apply temporary fix to fix build issue on m68k. Closes: #1087600.
  * Don't use -fno-inline-small-functions on hppa (Dave Anglin).
  * Build with -Os on sh4 (Adrian Glaubitz).
  * Stop using EXTRA_CFLAGS. Closes: #1087923.
  * Bump standards version.

  [ Stefano Rivera ]
  * Refresh patches.

 -- Matthias Klose <doko@debian.org>  Wed, 04 Dec 2024 10:39:10 +0100

python3.13 (3.13.0-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Adjust lib-argparse.diff to avoid failing test_argparse's translation
    test.

  [ Matthias Klose ]
  * Update to the 3.13 branch 2024-11-12.
  * Refresh patches.

 -- Matthias Klose <doko@debian.org>  Tue, 12 Nov 2024 10:54:22 +0100

=== debian/control ===
Source: python3.13
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Uploaders: Stefano Rivera <stefanor@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev | libeditreadline-dev, libncurses-dev, 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z),
  libssl-dev,
  libexpat1-dev,
  libbluetooth-dev [linux-any] <!pkg.python3.13.nobluetooth>,
  locales-all,
  libnsl-dev,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k],
  libgpm2 [linux-any],
  media-types | mime-support, netbase, bzip2, time, python3:any, python3.13:any <cross>,
  net-tools,
  python3-pip-whl <!nocheck>,
  python3-setuptools-whl <!nocheck>,
  python3-wheel-whl <!nocheck>,
  xvfb <!nocheck>, xauth <!nocheck>,
  tzdata <!nocheck>,
  systemtap-sdt-dev [!hurd-amd64 !hurd-i386],
  valgrind-if-available,
Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/cpython-team/python3
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
XS-Testsuite: autopkgtest

Package: python3.13
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.13-minimal (= ${binary:Version}),
 libpython3.13-stdlib (= ${binary:Version}),
 media-types | mime-support, tzdata,
 ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Suggests: python3.13-venv, python3.13-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2)
Description: Interactive high-level object-oriented language (version 3.13)
 Python is a high-level, interactive, object-oriented language. Its 3.13 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.13-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.13 (= ${binary:Version}),
 python3-pip-whl (>= 22.2),
 python3-setuptools-whl,
 ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.13)
 Python is a high-level, interactive, object-oriented language. Its 3.13 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.13 binary.

Package: libpython3.13-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.13-minimal (= ${binary:Version}),
  media-types | mime-support, netbase, tzdata,
  ${shlibs:Depends}, ${misc:Depends}
Description: Interactive high-level object-oriented language (standard library, version 3.13)
 Python is a high-level, interactive, object-oriented language. Its 3.13 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.13's standard library. It is normally not
 used on its own, but as a dependency of python3.13.

Package: python3.13-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.13-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.13
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.13)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.13-minimal/README.Debian for a list of the modules
 contained in this package.
XB-Cnf-Visible-Pkgname: python3.13

Package: python3.13-nopie
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.13-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Python interpreter linked without PIE (version 3.13)
 This package contains the interpreter not built as position independent
 executable. This interpreter is diverting the python3.13 executable, and making
 the interpreter built with PIE available as python3.13-pie.
XB-Cnf-Visible-Pkgname: python3.13

Package: libpython3.13-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.13-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Breaks: libpython3.13-stdlib (<< 3.13.1-3~)
Replaces: libpython3.13-stdlib (<< 3.13.1-3~)
Description: Minimal subset of the Python language (version 3.13)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.13-minimal.

Package: libpython3.13
Replaces: libpython3.13
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.13-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.13)
 Python is a high-level, interactive, object-oriented language. Its 3.13 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.13-examples
Architecture: all
Depends: python3.13:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.13)
 Examples, Demos and Tools for Python (v3.13). These are files included in
 the upstream Python distribution (v3.13).

Package: python3.13-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.13 (= ${binary:Version}),
  libpython3.13-dev (= ${binary:Version}),
  libpython3.13 (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.13)
 Header files, a static library and development tools for building
 Python (v3.13) modules, extending the Python interpreter or embedding
 Python (v3.13) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.13-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.13-stdlib (= ${binary:Version}),
  libpython3.13 (= ${binary:Version}),
  libexpat1-dev, zlib1g-dev,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.13)
 Header files, a static library and development tools for building
 Python (v3.13) modules, extending the Python interpreter or embedding
 Python (v3.13) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.13-dev.

Package: libpython3.13-testsuite
Section: libdevel
Architecture: all
Depends: python3.13 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.13)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.13-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.13-stdlib package).

Package: idle-python3.13
Architecture: all
Depends: python3.13, python3-tk, python3.13-tk,
  ${misc:Depends},
  libjs-mathjax,
Enhances: python3.13
Description: IDE for Python (v3.13) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.13).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.13-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.13
Description: Documentation for the high-level object-oriented language Python (v3.13)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.13). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.13
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.13-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.13 (= ${binary:Version}), libpython3.13-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.13)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.13-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.13-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: libpython3.13-dbg (<< ${source:Version}),
  python3-gdbm-dbg (<< 3.12.5-2~), python3-tk-dbg (<< 3.12.5-2~)
Replaces: libpython3.13-dbg,
  python3-gdbm-dbg (<< 3.12.5-2~), python3-tk-dbg (<< 3.12.5-2~)
Description: Debug Build of the Python Interpreter (version 3.13)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

Package: python3.13-full
Architecture: any
Multi-Arch: allowed
Depends: python3.13 (= ${binary:Version}),
  libpython3.13-testsuite,
  python3.13-venv (= ${binary:Version}),
  idle-python3.13,
  python3.13-gdbm,
  python3.13-tk,
  ca-certificates,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.13-doc, python3.13-examples,
Suggests: python3.13-dev
Description: Python Interpreter with complete class library (version 3.13)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on the full
 standard library of Python for Python developers. Including modules
 used only at build-time, such as venv, and modules with complex
 dependencies, such as tk and IDLE. All batteries included.
 .
 According to the Debian Python policy, this package must not be used in
 build dependencies, dependencies and recommendations.

Package: python3.13-tk
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: python3.13
Suggests: tix
Breaks: python3-tk (<< 3.12.5-2~)
Replaces: python3-tk (<< 3.12.5-2~)
XB-Python-Version: 3.13
Description: Tkinter - Writing Tk applications with Python (v3.13)
 A module for writing portable GUI applications with Python (v3.13) using Tk.
 Also known as Tkinter.

Package: python3.13-gdbm
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: python3.13
Breaks: python3-gdbm (<< 3.12.5-2~)
Replaces: python3-gdbm (<< 3.12.5-2~)
Description: GNU dbm database support for Python (v3.13)
 GNU dbm database module for Python. Install this if you want to
 create or read GNU dbm database files with Python.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

SPACE = $(EMPTY) $(EMPTY)
COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

# we inject our own lto flags
DPKG_OPTIMIZE = optimize=-lto
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)"dpkg-buildflags
ifeq (,$(filter $(distrelease),stretch buster bullseye trusty xenial bionic focal impish))
  with_nopie := yes
  dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
endif

# FIXME: remove sid when uploading to unstable, after bookworm is released
#ifneq (,$(filter $(distrelase), jessie stretch buster bullseye bookworm sid precise trusty xenial bionic focal groovy hirsute))
  with_dbmmodule = yes
  bd_dbm = libdb-dev
  dbmliborder = bdb:gdbm
#else
#  bd_dbm = libgdbm-compat-dev
#  dbmliborder = gdbm:bdb
#endif

ifneq (,$(filter valgrind, $(shell dpkg-query --show -f '$${Depends}\n' valgrind-if-available)))
  valgrind_configure_args = --with-valgrind
endif

VER=3.13
SVER=3.13.0~rc3
NVER=3.14
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := yes
with_gdbm := yes
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
  # test_ssl assumes that openssl is compiled with security level set to 1
  # make it so, during the build
  export OPENSSL_CONF = $(CURDIR)/debian/openssl.cnf
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

# configure and dtrace consume these
export CC CXX

# These variables are needed for the ELF package metadata (set via LDFLAGS)
DEB_BUILD_OS_RELEASE_ID=$(shell . /usr/lib/os-release && echo $$ID)
export DEB_BUILD_OS_RELEASE_ID
export DEB_HOST_ARCH
export DEB_SOURCE
export DEB_VERSION

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

DPKG_PIE_CPPFLAGS= $(shell $(dpkg_pieflags) --get CPPFLAGS)
DPKG_PIE_CFLAGS  := $(shell $(dpkg_pieflags) --get CFLAGS)
DPKG_PIE_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_PIE_CFLAGS))
DPKG_PIE_LDFLAGS = $(shell $(dpkg_pieflags) --get LDFLAGS)
OPT_PIE_CFLAGS   := $(filter-out -O%,$(DPKG_PIE_CFLAGS)) # default is -O3

ifeq ($(DEB_HOST_ARCH),ia64)
    DPKG_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
    DPKG_PIE_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
endif
# see https://gcc.gnu.org/PR81426
ifneq (,$(filter $(DEB_HOST_ARCH), sh4))
    OPT_CFLAGS += $(filter-out -O%,$(DPKG_CFLAGS)) -Os
    OPT_PIE_CFLAGS += $(filter-out -O%,$(DPKG_PIE_CFLAGS)) -Os
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    OPT_PIE_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
  with_pgo :=
endif

ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
  with_lto :=
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS)) -O0
    with_pgo =
    with_lto =
endif

BASE_LTO_CFLAGS = -g -fwrapv -O3
ifeq ($(with_lto),yes)
    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    OPT_CFLAGS += $(LTO_CFLAGS)
    OPT_PIE_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

sysconfig_substflags = \

## python3.13 3.13.2

=== debian/changelog ===
python3.13 (3.13.2-3) unstable; urgency=medium

  * Update to the 3.13 branch 2025-03-29.
  * Editorial changes for the python man page (Bjarni Ingi Gislason).
    Closes: #1101406.
  * Update the min-tempfile patch for 3.13. Closes: #1098680.

 -- Matthias Klose <doko@debian.org>  Sat, 29 Mar 2025 11:04:43 +0100

python3.13 (3.13.2-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Replace update-manpage.patch with the version that landed upstream.

  [ Matthias Klose ]
  * Update to the 3.13 branch 2025-03-13.
  * Generalize os testing in debian/rules (Samuel Thibault). Closes: #1095262.
  * Update sphinx build modules, still build with sphinx 8.1.x.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 13 Mar 2025 15:29:07 +0100

python3.13 (3.13.2-1) unstable; urgency=medium

  * Python 3.13.2.
  * Refresh patches.
  * Raise a more helpful ImportError in the turtle module. LP: #2093393.
  * Replace locale-module.patch with something to the change that landed
    upstream, and just missed 3.13.2.
  * Patch: update manpage, it has been neglected for a few releases.
    Closes: #1095052
  * Update symbols.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 04 Feb 2025 21:23:35 -0400

## python3.13 3.13.3

=== debian/changelog ===
python3.13 (3.13.3-1ubuntu0.3) plucky-security; urgency=medium

  * SECURITY UPDATE: Regular expression denial of service.
    - debian/patches/CVE-2025-6069.patch: Improve regex parsing in
      Lib/html/parser.py.
    - CVE-2025-6069
  * SECURITY UPDATE: Infinite loop when parsing tar archives.
    - debian/patches/CVE-2025-8194.patch: Raise exception when count < 0 in
      Lib/tarfile.py.
    - CVE-2025-8194

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Thu, 14 Aug 2025 09:23:40 -0230

python3.13 (3.13.3-1ubuntu0.2) plucky-security; urgency=medium

  * SECURITY UPDATE: Arbitrary filesystem and metadata write through improper
    tar filtering.
    - debian/patches/CVE-202x-12718-4138-4x3x-4517-pre1.patch: Add additional
      tests in ./Lib/test/test_ntpath.py and ./Lib/test/test_posixpath.py.
    - debian/patches/CVE-202x-12718-4138-4x3x-4517.patch: Add ALLOW_MISSING in
      ./Lib/genericpath.py, ./Lib/ntpath.py, ./Lib/posixpath.py. Change filter
      to handle errors in ./Lib/ntpath.py, ./Lib/posixpath.py. Add checks and
      unfiltered to ./Lib/tarfile.py. Modify tests.
    - CVE-2024-12718
    - CVE-2025-4138
    - CVE-2025-4330
    - CVE-2025-4435
    - CVE-2025-4517

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Mon, 16 Jun 2025 15:45:32 -0230

python3.13 (3.13.3-1ubuntu0.1) plucky-security; urgency=medium

  * SECURITY UPDATE: DoS via bytes.decode with unicode_escape
    - debian/patches/CVE-2025-4516.patch: fix use-after-free in the
      unicode-escape decoder with an error handler in
      Include/internal/pycore_bytesobject.h,
      Include/internal/pycore_unicodeobject.h,
      Lib/test/test_codeccallbacks.py, Lib/test/test_codecs.py,
      Objects/bytesobject.c, Objects/unicodeobject.c,
      Parser/string_parser.c.
    - CVE-2025-4516

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 26 May 2025 12:21:48 -0400

python3.13 (3.13.3-1) unstable; urgency=medium

  * Python 3.13.3.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 08 Apr 2025 15:55:40 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: python3.13
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Uploaders: Stefano Rivera <stefanor@debian.org>
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
@@ -26,8 +27,11 @@
   tzdata <!nocheck>,
   systemtap-sdt-dev [!hurd-amd64 !hurd-i386],
   valgrind-if-available,
-Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
-Standards-Version: 4.7.0
+Build-Depends-Indep: python3-sphinx,
+  python3-sphinx-notfound-page,
+  python3-sphinxext-opengraph,
+   python3-docs-theme, texinfo
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/cpython-team/python3
 Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
 XS-Testsuite: autopkgtest

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.13-dev,
  libpython3.13-testsuite:native,
  python3.13-gdbm,
  python3.13-tk,
  idle-python3.13,
  systemtap-sdt-dev,
  python3.13-venv,
  python3-wheel-whl,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: testsuite-dbg
Depends: build-essential,
  ca-certificates,
  locales-all, python3.13-dev,
  python3.13-dbg,
  libpython3.13-testsuite:native,
  gdb,
  idle-python3.13,
  systemtap-sdt-dev,
  python3.13-venv,
  python3-wheel-whl,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.13-dev,
  libpython3.13-testsuite:native,
  python3.13-gdbm,
  python3.13-tk,
  python3.13-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests-dbg
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.13-dev,
  python3.13-dbg,
  libpython3.13-testsuite:native,
  gdb,
  python3.13-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: module-install-local
Depends: build-essential,
  python3.13-dev,
  python3-pip,
  python3-setuptools,
  shunit2,
Restrictions: needs-root, allow-stderr

Tests: module-install-user
Depends: build-essential,
  python3.13-dev,
  python3-pip,
  python3-setuptools,
  shunit2
Restrictions: allow-stderr

Tests: module-install-venv
Depends: build-essential,
  python3.13-dev,
  python3.13-venv,
  python3-setuptools-whl,
  python3-wheel-whl,
  shunit2
Restrictions: allow-stderr

Tests: module-install-virtualenv
Depends: build-essential,
  python3.13-dev,
  shunit2,
  virtualenv,
  python3-setuptools-whl,
  python3-wheel-whl
Restrictions: allow-stderr

## python3.13 3.13.5

=== Doc/requirements.txt ===
# Requirements to build the Python documentation
#
# Note that when updating this file, you will likely also have to update
# the Doc/constraints.txt file.

# The Sphinx version is pinned so that new versions that introduce new warnings
# won't suddenly cause build failures. Updating the version is fine as long
# as no warnings are raised by doing so.
# Keep this version in sync with ``Doc/conf.py``.
sphinx~=8.2.0

blurb

sphinxext-opengraph~=0.10.0
sphinx-notfound-page~=1.0.0

# The theme used by the documentation is stored separately, so we need
# to install that as well.
python-docs-theme>=2023.3.1,!=2023.7

-c constraints.txt

=== debian/changelog ===
python3.13 (3.13.5-2) unstable; urgency=medium

  * Patch: Revert disabling of logger while handling log record.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 25 Jun 2025 20:55:22 +0200

python3.13 (3.13.5-1) unstable; urgency=medium

  * Python 3.13.5.
  * Refresh patches.
  * Drop patch no-wheel-whl.diff, superseded upstream.
  * Replace m68k-alignment-fix.diff with gchead-alignment.diff, the patch that
    landed upstream.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 12 Jun 2025 09:03:44 +0200

python3.13 (3.13.4-1) unstable; urgency=medium

  * Python 3.13.4.

 -- Matthias Klose <doko@debian.org>  Tue, 03 Jun 2025 21:15:26 +0200

python3.13 (3.13.3-4) unstable; urgency=medium

  * Update to the 3.13 branch 2025-05-21.
    - Fix gh-133767, CVE-2025-4516.

 -- Matthias Klose <doko@debian.org>  Wed, 21 May 2025 09:49:52 +0200

python3.13 (3.13.3-3) unstable; urgency=medium

  [ Stefano Rivera ]
  * Update control.in for the changes in 3.13.3-2.
  * Replace no-wheel-whl.diff with upstream version.
  * Patch: Use shutil.which() in missing_compiler_executable().

  [ Matthias Klose ]
  * Update VCS attributes.
  * Update to the 3.13 branch 2025-05-20.
  * Remove patches applied upstream.

 -- Matthias Klose <doko@debian.org>  Tue, 20 May 2025 08:57:58 +0200

python3.13 (3.13.3-2) unstable; urgency=medium

  * Drop depends and test depends on python3-wheel-whl, setuptools has native
    bdist_wheel support.
  * Patch: Avoid needing python3-wheel-whl for the testsuite.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 10 Apr 2025 17:38:51 -0400

## python3.13 3.13.7

=== debian/changelog ===
python3.13 (3.13.7-1ubuntu0.3) questing-security; urgency=medium

  * SECURITY UPDATE: Header injection in email messages where addresses are not
    sanitized.
    - debian/patches/CVE-2025-11468.patch: Add escape parentheses and backslash
      in Lib/email/_header_value_parser.py. Add test in
      Lib/test/test_email/test__header_value_parser.py.
    - CVE-2025-11468
  * SECURITY UPDATE: Quadratic algorithm when building excessively nested XML
    documents.
    - debian/patches/CVE-2025-12084-*.patch: Remove _in_document and replace
      with node.ownerDocument in Lib/xml/dom/minidom.py. Set self.ownerDocument
      to None in Lib/xml/dom/minidom.py. Add test in Lib/test/test_minidom.py.
    - CVE-2025-12084
  * SECURITY UPDATE: OOM and denial of service when opening malicious plist
    file.
    - debian/patches/CVE-2025-13837.patch: Add _MIN_READ_BUF_SIZE and _read
      with checks in Lib/plistlib.py. Add test in Lib/test/test_plistlib.py.
    - CVE-2025-13837
  * SECURITY UPDATE: Header injection in user controlled data URLs in urllib.
    - debian/patches/CVE-2025-15282.patch: Add control character checks in
      Lib/urllib/request.py. Add test in Lib/test/test_urllib.py.
  * SECURITY UPDATE: Command injection through user controlled commands in
    imaplib.
    - debian/patches/CVE-2025-15366.patch: Add _control_chars and checks in
      Lib/imaplib.py. Add test in Lib/test/test_imaplib.py.
  * SECURITY UPDATE: Command injection through user controlled commands in
    poplib.
    - debian/patches/CVE-2025-15367.patch: Add control character regex check
      in Lib/poplib.py. Add test in Lib/test/test_poplib.py.
    - CVE-2025-15367
  * SECURITY UPDATE: HTTP header injection in user controlled cookie values.
    - debian/patches/CVE-2026-0672.patch: Add _control_characters_re and
      checks in Lib/http/cookies.py. Add test in Lib/test/test_http_cookies.py.
    - CVE-2026-0672
  * SECURITY UPDATE: HTTP header injection in user controlled headers and
    values with newlines.
    - debian/patches/CVE-2026-0865.patch: Add _control_chars_re and check in
      Lib/wsgiref/headers.py. Add test in Lib/test/support/__init__.py and
      Lib/test/test_wsgiref.py.
    - CVE-2026-0865

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Thu, 22 Jan 2026 16:45:57 -0330

python3.13 (3.13.7-1ubuntu0.2) questing-security; urgency=medium

  * SECURITY UPDATE: HTTP Content-Length denial of service
    - debian/patches/CVE-2025-13836.patch: Read large data in chunks with
      geometric reads in Lib/http/client.py and add tests in 
      Lib/test/test_httplib.py
    - CVE-2025-13836

 -- Vyom Yadav <vyom.yadav@canonical.com>  Thu, 08 Jan 2026 17:45:45 +0530

python3.13 (3.13.7-1ubuntu0.1) questing-security; urgency=medium

  * SECURITY UPDATE: Possible payload obfuscation
    - debian/patches/CVE-2025-8291.patch: check consistency of
      the zip64 end of central dir record in Lib/zipfile.py,
      Lib/test/test_zipfile.py.
    - CVE-2025-8291
  * SECURITY UPDATE: Performance degradation
    - debian/patches/CVE-2025-6075.patch: fix quadratic complexity
      in os.path.expandvars() in Lib/ntpatch.py, Lib/posixpath.py,
      Lib/test/test_genericpatch.py, Lib/test/test_npath.py.
    - CVE-2025-6075

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Mon, 24 Nov 2025 17:21:28 -0330

python3.13 (3.13.7-1) unstable; urgency=medium

  * Python 3.13.7.
  * Patch: Use a list for epub_exclude_files in Sphinx config.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 21 Aug 2025 00:17:40 +0200

python3.13 (3.13.6-1) unstable; urgency=medium

  * Python 3.13.6.
    - Fixes CVE-2025-6069: Quadratic complexity in processing special input in
      HTMLParser.
    - Fixes CVE-2025-8194: Potential DoS in tarfile extraction.
  * Refresh patches.
  * Drop patch revert-logger-disable.diff, superseded upstream.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 07 Aug 2025 12:53:54 +0200

=== debian/control ===
--- 
+++ 
@@ -21,8 +21,7 @@
   media-types | mime-support, netbase, bzip2, time, python3:any, python3.13:any <cross>,
   net-tools,
   python3-pip-whl <!nocheck>,
-  python3-setuptools-whl <!nocheck>,
-  python3-wheel-whl <!nocheck>,
+  python3-setuptools-whl (>= 70.1) <!nocheck>,
   xvfb <!nocheck>, xauth <!nocheck>,
   tzdata <!nocheck>,
   systemtap-sdt-dev [!hurd-amd64 !hurd-i386],
@@ -32,8 +31,8 @@
   python3-sphinxext-opengraph,
    python3-docs-theme, texinfo
 Standards-Version: 4.7.2
-Vcs-Browser: https://salsa.debian.org/cpython-team/python3
-Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
+Vcs-Browser: https://salsa.debian.org/cpython-team/python3/tree/python3.13
+Vcs-Git: https://salsa.debian.org/cpython-team/python3.git -b python3.13
 XS-Testsuite: autopkgtest
 
 Package: python3.13
@@ -60,7 +59,7 @@
 Priority: optional
 Depends: python3.13 (= ${binary:Version}),
  python3-pip-whl (>= 22.2),
- python3-setuptools-whl,
+ python3-setuptools-whl (>= 70.1),
  ${shlibs:Depends}, ${misc:Depends},
 Breaks: python3-pip (<< 1.5.6-4)
 Description: Interactive high-level object-oriented language (pyvenv binary, version 3.13)

## python3.13 3.13.8

=== debian/changelog ===
python3.13 (3.13.8-1) unstable; urgency=medium

  * Python 3.13.8.

  [ Stefano Rivera ]
  * Revert the Sphinx config patch, now that we have sphinx 8.2 in unstable.

  [ Matthias Klose ]
  * Refresh patches.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Oct 2025 11:16:25 +0200

## python3.13 3.13.9

=== debian/changelog ===
python3.13 (3.13.9-1) unstable; urgency=medium

  * Python 3.13.9.
  * Refresh patches.
  * Patch: Support docutils 0.22.
  * Patch: m68k: Avoid SIGILL when built with GCC 15.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 15 Oct 2025 16:56:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: python3.13
 Section: python
 Priority: optional
-Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Uploaders: Stefano Rivera <stefanor@debian.org>
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
   quilt, autoconf,

=== debian/rules ===
--- 
+++ 
@@ -38,10 +38,10 @@
   WITHOUT_BENCH := yes
 endif
 ifeq ($(on_buildd),yes)
-  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
+  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390)$(filter $(DEB_HOST_ARCH_OS), hurd kfreebsd))
     WITHOUT_CHECK := yes
   endif
-  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
+  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390)$(filter $(DEB_HOST_ARCH_OS), hurd kfreebsd))
     WITHOUT_BENCH := yes
   endif
 endif
@@ -240,4 +240,3 @@
     RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
 endif
 
-sysconfig_substflags = \

## python3.13 3.13.11

=== debian/changelog ===
python3.13 (3.13.11-1) unstable; urgency=medium

  * Python 3.13.11.
  * Fix the tempfile module in python3.13-minimal (min-tempfile.diff).
    (LP: #2127898)
  * Build with -O1 on m68k. Closes: #1121974

 -- Stefano Rivera <stefanor@debian.org>  Sat, 06 Dec 2025 09:15:20 -0400

=== debian/rules ===
--- 
+++ 
@@ -200,6 +200,11 @@
     DEBUG_CFLAGS += -fexceptions
 endif
 
+ifneq (,$(filter $(DEB_HOST_ARCH), m68k))
+    OPT_CFLAGS += $(filter-out -O%,$(DPKG_CFLAGS)) -O1
+    OPT_PIE_CFLAGS += $(filter-out -O%,$(DPKG_PIE_CFLAGS)) -O1
+endif
+
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
   ifeq ($(DEB_HOST_ARCH_OS),linux)
     ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
@@ -234,9 +239,3 @@
     ifeq ($(with_fat_lto),yes)
       LTO_CFLAGS += -ffat-lto-objects
     endif
-    OPT_CFLAGS += $(LTO_CFLAGS)
-    OPT_PIE_CFLAGS += $(LTO_CFLAGS)
-    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
-    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
-endif
-

=== debian/watch ===
version=4
opts=dversionmangle=s/.*\+//,\
  uversionmangle=s/([abcr]+[1-9])$/~$1/,\
  pgpsigurlmangle=s/$/.asc/ \
  http://www.python.org/ftp/python/3\.13(\.\d+)?/Python-(3\.13[.\dabcr]*)\.tar.xz

## python3.13 3.13.12

=== debian/changelog ===
python3.13 (3.13.12-1) unstable; urgency=medium

  * Python 3.13.12.
    - Ensures that Element & Attr instances have the ownerDocument
      attribute. Closes: #1122875
    - Reject control characters in wsgiref.headers.Headers. Closes: #1126740,
      CVE-2026-0865.
    - email: verify headers are sound in BytesGenerator. Closes: #1126745,
      CVE-2026-1299.
    - Reject control characters in http cookies. Closes: #1126762,
      CVE-2026-0672.
    - Reject control characters in data: URL mediatype. Closes: #1126780,
      CVE-2025-15282.
    - email: Preserve parens when folding comments. Closes: #1126787,
      CVE-2025-11468.
  * Refresh patches.
  * Drop m68k patch, merged upstream.
  * Drop -Os from CFLAGS for sh4. Closes: #1122045
  * Patch: Handle missing _pyrepl in _sitebuiltins under python3.13-minimal.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 04 Feb 2026 11:06:39 -0400

=== debian/rules ===
--- 
+++ 
@@ -189,11 +189,7 @@
     DPKG_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
     DPKG_PIE_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
 endif
-# see https://gcc.gnu.org/PR81426
-ifneq (,$(filter $(DEB_HOST_ARCH), sh4))
-    OPT_CFLAGS += $(filter-out -O%,$(DPKG_CFLAGS)) -Os
-    OPT_PIE_CFLAGS += $(filter-out -O%,$(DPKG_PIE_CFLAGS)) -Os
-endif
+
 ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
     OPT_CFLAGS += -fexceptions
     OPT_PIE_CFLAGS += -fexceptions
@@ -239,3 +235,10 @@
     ifeq ($(with_fat_lto),yes)
       LTO_CFLAGS += -ffat-lto-objects
     endif
+    OPT_CFLAGS += $(LTO_CFLAGS)
+    OPT_PIE_CFLAGS += $(LTO_CFLAGS)
+    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
+    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
+endif
+
+sysconfig_substflags = \
